#include <iostream>
#include <cmath>
#include <cstdio>
using namespace std;
int main() {
    long int h;
    long int n;
    scanf("%ld %ld", &h, &n);
    int vodopad[100][100];
    long int protok[100];
    for (int u=0; u<n; u++) {
        protok[u]=1;
    }
    for (long int r=0;r<h;r++) {
        for (long int l=0;l<n;l++) {
            scanf("%d",&vodopad[r][l]);
        }
    }
    long int zbir=0;
    long int prvi=0;
    long int poslednji=0;
    int k=0;
    int i=0;
    for(int p=0; p<h; p++) {
    zbir=0;
    prvi=0;
    poslednji=0;
    k=0;
    i=0;
    while (i<n) {
        if (vodopad[p][i]==1) {
            i++;
            continue;
        }
        else {
            prvi=i;
            k=i;
            while (k<n&&vodopad[p][k]==0) {
                zbir=zbir+protok[k];
                protok[k]=0;
                k++;
            }
            poslednji = k-1;
            if (prvi==0) {
                protok[poslednji+1]+=zbir;
            }
            else if (poslednji==n-1) {
                protok[prvi-1]+=zbir;
            }
            else if (zbir%2==0) {
                protok[prvi-1]+=zbir/2;
                protok[poslednji+1]+=zbir/2;
            }
            else if ((p+1)%2==1){
                protok[prvi-1]+=zbir/2+1;
                protok[poslednji+1]+=zbir/2;
            }
            else {
                protok[prvi-1]+=zbir/2;
                protok[poslednji+1]+=zbir/2+1;
            }
            zbir=0;
            i=poslednji+2;
        }
    }
    }
    for (int f=0;f<n;f++) {
        printf("%ld ",protok[f]);
    }
    return 0;
}